一、容斥典型问题
求在给定区间内,能被给定集合至少一个数整除的数个数
二、解题思路
将给出的\(n\)个整除的数进行二进制枚举(\(2^n\)),计算\(a_i\)所能组成的各种集合(这里将集合中\(a_i\)的最小公倍数作为除数)在区间中满足的数的个数,然后利用容斥原理实现加减
三、同类问题
AcWing 890. 能被整除的数
与这个模板题相对,增加了两个变化:
- 1、在给定的数中由于他们的关系不是互质的,所以要计算他们的\(lcm\),而不是他们直接相乘 比如 \(2\) \(4\)
- 2、在题目中说给定的数是非负的,所以在样例会会出现\(0\),在计算时要将其拿掉~
四、实现代码
#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
const int N = 15;
LL a[N];
LL p[N], idx;
//最小公倍数
LL lcm(LL a, LL b) {
return a * b / __gcd(a, b);
}
int main() {
//加快读入
ios::sync_with_stdio(false);
cin.tie(0);
cout.tie(0);
int n, m;
while (cin >> n >> m) {
n--; // small than N 注意细节
idx = 0; //多组测试数据,注意清0
for (int i = 0; i < m; i++) cin >> a[i];
for (int i = 0; i < m; i++)
if (a[i]) p[idx++] = a[i]; //排除掉数字0
LL res = 0;
for (int i = 1; i < (1 << idx); i++) {
int cnt = 0;
LL t = 1;
for (int j = 0; j < idx; j++) {
if (i >> j & 1) {
cnt++;
t = lcm(t, p[j]);
}
}
if (cnt & 1)
res += n / t;
else
res -= n / t;
}
cout << res << endl;
}
return 0;
}